/*
 * pwm_section.c
 *
 * Created: 02.02.2018 12:05:11
 *  Author: peter
 */ 
/* Fast PWM Mode  About 20 kHz*/
/*
*/

#include <avr/io.h>
#include <avr/interrupt.h>

extern volatile uint8_t pwm_value;


ISR(TIMER0_COMPA_vect){
	
	OCR0A = pwm_value;		// Load current / new value into 0CR0A 
	
}

void pwm_init(void){		/* Toggle port OC0A at match, no prescaling */
	
	TCCR0A = ( 1 << COM0A1 ) | ( 1 << COM0A0) | ( 1 << WGM00 ) | ( 1 << WGM01);			// Set fast pwm, set bit when match, clr on top when COMA0A is set additionally
																						// else reversed if COMA0A is omitted
	TCCR0B = ( 1 << CS00 );												// Clk I/O direct
	OCR0A = pwm_value;													// load with current value  
	TIMSK |= ( 1 << OCIE0A);											// enable Interrupt
	DDRB |= (1 << PB2 );												// set PIN 14 on DIP Chip as output		
}
