
#include <avr/io.h>
#include <avr/interrupt.h>


#define PRESCALER0      ((1 << CS00) | (1 << CS02))		 // CLK/1024
#define PRESCALER1		((1 << CS12)|  (1 << CS10))		// dto.
#define PRESCALER1_256	((1 << CS12))
#define PRESCALER1_64	((1 << CS10) | ( 1 << CS11))
#define KEY_POWER		(PIND & (1 << PD1)) // Key

 volatile uint8_t tick;
 volatile uint8_t tick_key;
 volatile uint8_t key_press=0;

void init_timer( void ) // ATtiny 2313
{
	
	
	/* Init Timer1*/
	TIMSK  |=  (1 <<  OCIE1A);	// enable interrupt for OCR1A
	
	TCCR1B |= (1 << WGM12 ) | PRESCALER1;				// Prescaler 1024 / 0.256 ms at 4 MHz
	OCR1A = 4;											// 1 ms clocking
	TCNT1 = 0; 							 // Set to zero
	

}
ISR(TIMER1_COMPA_vect){

		static uint8_t key_state=0;
		static uint8_t ct0=0, ct1=0,i=0;
  	
	tick++;	
	
	if (++tick_key == 20){		// every 20ms check the key


    
 

 			i = key_state ^ ~(KEY_POWER);   // key changed ?

 			ct0 = ~( ct0 & i );			// reset or count ct0
  			ct1 = (ct0 ^ ct1) & i;	    // reset or count ct1  
  			i &= ct0 & ct1;			    // count until roll over ?
  			key_state ^= i;			    // then toggle debounced state
  
  /*
   * To notify main program of pressed key, the corresponding bit
   * in global variable key_press is set.
   * The main loop needs to clear this bit
   */
  			key_press |= key_state & i;	// 0->1: key press detect
	tick_key=0;
	}
	
}
void wait_ms(uint8_t ms){
	
	tick = 0;
	while ( tick < ms);
	
}